#!/usr/bin/perl -w
#
# Add categories into kde desktop files.
#
# Usage: kdedesktop2mdkmenu.pl package section input_file output_file
#
# Copyright: MandrakeSoft, licensed under the GPL v2.

my @nested = (["Configuration", "System/Configuration"],

       ["Applications/Monitoring", "System/Monitoring"],
       ["Applications/Publishing", "Office/Publishing"],
       ["Applications/File tools", "System/File Tools"],
       ["Applications/Text tools", "System/Text Tools"],
       ["Applications/Archiving", "System/Archiving"],
       ["Applications", "More Applications"],

       ["Terminals", "System/Terminals"],

       ["Documentation", "More Applications/Documentation"],

           ["Office/PDA", "Office/Communications/PDA"],

       ["Networking/IRC", "Internet/Chat"],
       ["Networking/WWW", "Internet/Web Browsers"],
       ["^Networking", "Internet"],

       ["Amusement", "More Applications/Games"],
       ["Session/Windowmanagers", "System/Session/Windowmanagers"],
       );

sub translate {
    my ($str) = @_;

    foreach my $t (@nested) {
    if ($str =~ /(.*)$t->[0](.*)/ && $str !~ /$t->[1]/) {
        print "$str => $1$t->[1]$2\n";
        return "$1$t->[1]$2";
    }
    }
    return $str;
}

(($#ARGV == 1) or ($#ARGV == 2) ) or die "E: You gave me $#ARGV parameters. This script must be invoked with parameters: <file_in> <section> [requires]\n";

my $section = $ARGV[1];
my $requires = (defined $ARGV[2]) ? $ARGV[2] : "x11";
($requires eq "text") or ($requires eq "x11") or ($requires eq "kde") or print "W: requires is $requires (e.g. not text nor x11 nor kde\n";

$section = translate($section);

($section =~ /\"/) and die "E: Section should not contain some \" characters\n";

#print "section before $section";
# remove last "/"
$section =~ s!/$!!;
# change "/" to "-"
$section =~ s!/!-!g;
# remove space
$section =~ s/ //g;

# add X-MandrivaLinux section
$section = "X-MandrivaLinux-$section";

print "section $section \n";
print "file name : $ARGV[0]\n";
# execute createmdkmenu
system("createmdkmenu.sh",$ARGV[0], $section, $requires);
